/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";define("vs/languages/typescript/common/features/tokenization",["require","exports","vs/base/common/strings","vs/base/common/arrays","vs/base/common/collections","vs/editor/common/modes","vs/editor/common/modes/supports","vs/languages/vsxml/common/vsxml","vs/editor/common/modes/lineStream","vs/languages/typescript/common/lib/typescriptServices","vs/editor/common/modes/abstractState"],function(e,t,n,r,o,i,s,a,c,l,u){function d(e,t){var n=l.createClassifier(),r=t===f.TypeScript?b:w,o=t===f.TypeScript?y:_;return{shouldGenerateEmbeddedModels:!1,getInitialState:function(){return new g(e,null,t,0,!1)},tokenize:function(e,t,i,s){return h(r,o,n,t,e,i,s)}}}function h(e,t,o,a,c,u){function d(e,t,n){(0===h.tokens.length||void 0!==n||r.tail(h.tokens).type!==t)&&h.tokens.push(new s.Token(e,t,n||i.Bracket.None))}void 0===u&&(u=0);var h={tokens:[],actualStopOffset:u+c.length,endState:new g(a.getMode(),a.getStateData(),a.language,0,!1),modeTransitions:[{startIndex:u,mode:a.getMode()}]};if(0===a.eolState&&m(a,u,c,d))return h;var b=a.language===f.TypeScript;if(!b&&p(a,u,c,d))return h;var y=o.getClassificationsForLine(c,a.eolState,!0),w=0;h.endState.eolState=y.finalLexState,h.endState.inJsDocComment=1===y.finalLexState&&(a.inJsDocComment||/\/\*\*.*$/.test(c));for(var _=0,k=y.entries;_<k.length;_++){var S,x=k[_],T=i.Bracket.None;if(x.classification===l.TokenClass.Punctuation){var C=c.charCodeAt(w);T=v[C]||i.Bracket.None,S=e[C]||t[x.classification],d(w+u,S,T)}else x.classification===l.TokenClass.Comment?h.endState.inJsDocComment||/\/\*\*.*\*\//.test(c.substr(w,x.length))?d(w+u,b?"comment.doc.ts":"comment.doc.js",i.Bracket.None):d(w+u,b?"comment.ts":"comment.js",i.Bracket.None):d(w+u,t[x.classification]||n.empty,void 0);w+=x.length}return h}function p(e,t,n,r){return 0===n.indexOf("#!")?(r(t,"comment.shebang",i.Bracket.None),!0):void 0}function m(e,t,n,r){if(!n.match(k))return!1;var o,s,l=new c.LineStream(n),u=new a.VSXMLExpression(e.getMode(),e);for(l.advanceIfRegExp(k).length>0&&r(t,"comment.vs",i.Bracket.None);!l.eos();){s=l.pos();do{if(o=u.tokenize(l),null===o||void 0===o||(void 0===o.type||null===o.type)&&(void 0===o.nextState||null===o.nextState))throw new Error("Tokenizer must return a valid state");if(o.nextState&&(o.nextState.setStateData(u.getStateData()),u=o.nextState),l.pos()<=s)throw new Error}while(!o.type&&""!==o.type);r(s+t,o.type,o.bracket)}return!0}!function(e){e[e.TypeScript=0]="TypeScript",e[e.EcmaScript5=1]="EcmaScript5"}(t.Language||(t.Language={}));var f=t.Language;t.createTokenizationSupport=d;var g=function(){function e(e,t,n,r,o){this._mode=e,this._state=t,this.language=n,this.eolState=r,this.inJsDocComment=o}return e.prototype.clone=function(){return new e(this._mode,u.AbstractState.safeClone(this._state),this.language,this.eolState,this.inJsDocComment)},e.prototype.equals=function(t){return t===this?!0:t&&t instanceof e?this.eolState!==t.eolState?!1:this.inJsDocComment!==t.inJsDocComment?!1:u.AbstractState.safeEquals(this._state,t._state):!1},e.prototype.getMode=function(){return this._mode},e.prototype.tokenize=function(){throw new Error},e.prototype.getStateData=function(){return this._state},e.prototype.setStateData=function(e){this._state=e},e}(),v=o.createNumberDictionary();v["(".charCodeAt(0)]=i.Bracket.Open,v[")".charCodeAt(0)]=i.Bracket.Close,v["{".charCodeAt(0)]=i.Bracket.Open,v["}".charCodeAt(0)]=i.Bracket.Close,v["[".charCodeAt(0)]=i.Bracket.Open,v["]".charCodeAt(0)]=i.Bracket.Close;var b=o.createNumberDictionary();b["(".charCodeAt(0)]="delimiter.parenthesis.ts",b[")".charCodeAt(0)]="delimiter.parenthesis.ts",b["{".charCodeAt(0)]="delimiter.bracket.ts",b["}".charCodeAt(0)]="delimiter.bracket.ts",b["[".charCodeAt(0)]="delimiter.array.ts",b["]".charCodeAt(0)]="delimiter.array.ts";var y=o.createNumberDictionary();y[l.TokenClass.Identifier]="identifier.ts",y[l.TokenClass.Keyword]="keyword.ts",y[l.TokenClass.Operator]="delimiter.ts",y[l.TokenClass.Punctuation]="delimiter.ts",y[l.TokenClass.NumberLiteral]="number.ts",y[l.TokenClass.RegExpLiteral]="regexp.ts",y[l.TokenClass.StringLiteral]="string.ts";var w=o.createNumberDictionary();w["(".charCodeAt(0)]="delimiter.parenthesis.js",w[")".charCodeAt(0)]="delimiter.parenthesis.js",w["{".charCodeAt(0)]="delimiter.bracket.js",w["}".charCodeAt(0)]="delimiter.bracket.js",w["[".charCodeAt(0)]="delimiter.array.js",w["]".charCodeAt(0)]="delimiter.array.js";var _=o.createNumberDictionary();_[l.TokenClass.Identifier]="identifier.js",_[l.TokenClass.Keyword]="keyword.js",_[l.TokenClass.Operator]="delimiter.js",_[l.TokenClass.Punctuation]="delimiter.js",_[l.TokenClass.NumberLiteral]="number.js",_[l.TokenClass.RegExpLiteral]="regexp.js",_[l.TokenClass.StringLiteral]="string.js";var k=/^\s*\/\/\//}),define("vs/platform/request/common/request",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IRequestService=n.createDecorator("requestService")}),define("vs/platform/workspace/common/workspace",["require","exports","vs/platform/instantiation/common/instantiation"],function(e,t,n){t.IWorkspaceContextService=n.createDecorator("contextService")});var __decorate=this&&this.__decorate||function(e,t,n,r){if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)return Reflect.decorate(e,t,n,r);switch(arguments.length){case 2:return e.reduceRight(function(e,t){return t&&t(e)||e},t);case 3:return e.reduceRight(function(e,r){return r&&r(t,n),void 0},void 0);case 4:return e.reduceRight(function(e,r){return r&&r(t,n,e)||e},r)}},__param=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define("vs/languages/typescript/common/features/quickFixMainActions",["require","exports","vs/nls!vs/languages/javascript/common/javascript","vs/base/common/winjs.base","vs/platform/files/common/files","vs/platform/request/common/request","vs/platform/workspace/common/workspace"],function(e,t,n,r,o,i,s){var a=function(){function e(e,t,n){this._requestService=e,this._fileService=t,this._contextService=n}return e.prototype.evaluate=function(e,t,n){var o=JSON.parse(n);switch(o.type){case"typedefinitions":return this.evaluateAddTypeDefinitionProposal(o.name,e)}return r.Promise.as(null)},e.prototype.evaluateAddTypeDefinitionProposal=function(e){var t=this,r="/typings/"+e,o="/jsconfig.json";return this._fileService.resolveFileStat(r).then(function(){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",0,r)}},function(){var i="https://raw.githubusercontent.com/borisyankov/DefinitelyTyped/master/"+e;return t._requestService.makeRequest({url:i,followRedirects:5}).then(function(e){return t._fileService.createFile(r,e.responseText).then(function(){return t._fileService.resolveFileStat(o).then(function(){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",1,r)}},function(){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",2,r)}})},function(e){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",3,r,e.toString())}})},function(e){return{message:n.localize("vs_languages_typescript_common_features_quickFixMainActions",4,i,e.toString())}})})},e=__decorate([__param(0,i.IRequestService),__param(1,o.IFileService),__param(2,s.IWorkspaceContextService)],e)}();t.QuickFixMainActions=a}),define("vs/languages/typescript/common/typescript",["require","exports","vs/platform/platform","vs/base/common/uri"],function(e,t,n,r){function o(){return{resolveProjects:function(){return void 0},resolveFiles:function(){return void 0}}}function i(e){return"string"==typeof e?0===e.indexOf("ts://defaultlib"):"ts"===e.scheme&&"defaultlib"===e.authority}!function(e){e[e.Changed=0]="Changed",e[e.Added=1]="Added",e[e.Removed=2]="Removed"}(t.ChangeKind||(t.ChangeKind={}));t.ChangeKind;t.createDefaultProjectResolver=o,t.defaultLib=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.d.ts"),t.defaultLibES6=r.create("ts","defaultlib","/vs/text!vs/languages/typescript/common/lib/lib.es6.d.ts"),t.isDefaultLib=i,t.virtualProjectResource=r.create("ts","projects","/virtual/1");var s;!function(e){function t(e){o=e}function r(){return o}e.Identifier="typescript",n.Registry.add(e.Identifier,e);var o;e.setProjectResolver=t,e.getProjectResolver=r}(s=t.Extensions||(t.Extensions={}))});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/typescript/common/typescriptMode",["require","exports","vs/nls!vs/languages/javascript/common/javascript","vs/base/common/winjs.base","vs/base/common/uri","vs/editor/common/common","vs/base/common/lifecycle","vs/base/common/async","vs/editor/common/modes/supports","vs/languages/typescript/common/features/tokenization","vs/languages/typescript/common/features/quickFixMainActions","vs/languages/typescript/common/typescript","vs/editor/common/modes/abstractMode","vs/platform/thread/common/threadService","vs/platform/instantiation/common/descriptors","vs/platform/thread/common/thread"],function(e,t,n,r,o,i,s,a,c,l,u,d,h,p,m,f){var g=function(){function e(e,t){this._listener=Object.create(null),this._lastValidationReq=0,this._modelService=e.modelService,this._mode=t,this._validation=new a.RunOnceScheduler(this._doValidate.bind(this),750),this._modelService?(this._modelService.onModelAdded.add(this._onModelAdded,this),this._modelService.onModelRemoved.add(this._onModelRemoved,this),this._modelService.getModels().forEach(this._onModelAdded,this)):console.warn("NO model service for validation")}return e.prototype.dispose=function(){this._validation.dispose()},e.prototype.validateOpen=function(){this._scheduleValidation()},e.prototype._scheduleValidation=function(e){this._lastValidationReq+=1,this._lastChangedResource=e,this._validation.schedule()},e.prototype._doValidate=function(){var e=this,t=[];this._lastChangedResource&&t.push(this._lastChangedResource);for(var n in this._listener)this._lastChangedResource&&n===this._lastChangedResource.toString()||t.push(o.parse(n));var i=this._lastValidationReq,s=a.sequence(t.map(function(t){return function(){return e._modelService.getModel(t)?i===e._lastValidationReq?e._mode.performSemanticValidation(t):void 0:r.Promise.as(void 0)}}));s.done(void 0,function(e){return console.warn(e)})},e.prototype._onModelAdded=function(e){var t=this;if(this._mode._shouldBeValidated(e)){var n,r;n=function(){t._scheduleValidation(e.getAssociatedResource())},r=e.addListener(i.EventType.ModelContentChanged2,function(){return n()}),this._listener[e.getAssociatedResource().toString()]=r,n()}},e.prototype._onModelRemoved=function(e){var t=this._listener[e.getAssociatedResource().toString()];t&&(t(),delete this._listener[e.getAssociatedResource().toString()])},e}(),v=function(t){function o(e,n,o){var i=this;if(t.call(this,e,n,o,m.AsyncDescriptor.create("vs/languages/typescript/common/typescriptWorker2","TypeScriptWorker2")),this._disposables=[],this._telemetryService=e.telemetryService,this._threadService&&this._threadService.isInMainThread){this._semanticValidator=e.instantiationService.createInstance(g,this),this._disposables.push(this._semanticValidator);var s=this._getProjectResolver();this._projectResolver=s?e.instantiationService.createInstance(s,this).then(void 0,function(e){return console.error(e),d.createDefaultProjectResolver()}):r.TPromise.as(d.createDefaultProjectResolver())}this.navigateTypesSupport=this,this.extraInfoSupport=this,this.formattingSupport=this,this.quickFixSupport=this,this.logicalSelectionSupport=this,this.outlineSupport=this,this.emitOutputSupport=this,this.codeLensSupport=this,this.renameSupport=this,this.tokenizationSupport=l.createTokenizationSupport(this,l.Language.TypeScript),this.electricCharacterSupport=new c.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.ts",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.ts",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.ts",open:"(",close:")",isElectric:!0}],docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}}),this.referenceSupport=new c.ReferenceSupport(this,{tokens:["identifier.ts"],findReferences:function(e,t,n){return i.findReferences(e,t,n)}}),this.declarationSupport=new c.DeclarationSupport(this,{tokens:["identifier.ts","string.ts","attribute.value.vs"],findDeclaration:function(e,t){return i.findDeclaration(e,t)}}),this.parameterHintsSupport=new c.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["string.ts"],getParameterHints:function(e,t){return i.getParameterHints(e,t)}}),this.characterPairSupport=new c.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]},{open:"`",close:"`"}]}),this.suggestSupport=new c.SuggestSupport(this,{triggerCharacters:["."],excludeTokens:["string","comment","number"],sortBy:[{type:"reference",partSeparator:"/"}],suggest:function(e,t){return i.suggest(e,t)},getSuggestionDetails:function(e,t,n){return i.getSuggestionDetails(e,t,n)}})}return __extends(o,t),o.prototype.dispose=function(){this._disposables=s.disposeAll(this._disposables)},o.prototype._shouldBeValidated=function(e){return e.getMode()===this||/\.ts$/.test(e.getAssociatedResource().fsPath)},o.prototype._getProjectResolver=function(){return d.Extensions.getProjectResolver()},o.prototype.acceptProjectChanges=function(e){return this._semanticValidator.validateOpen(),this._doAcceptProjectChanges(e)},o.prototype._doAcceptProjectChanges=function(e){return this._worker(function(t){return t.acceptProjectChanges(e)})},o.prototype.acceptFileChanges=function(e){for(var t=this,o=0,i=0;i<e.length;i++){var s=e[i];s.content&&(o+=s.content.length)}return this._canAcceptFileChanges(o).then(function(o){return o?t._doAcceptFileChanges(e).then(function(e){return t._semanticValidator.validateOpen(),e}):r.TPromise.wrapError(n.localize("vs_languages_typescript_common_typescriptMode",0))})},o.prototype._canAcceptFileChanges=function(e){return this._worker(function(t){return t.canAcceptFileChanges(e)})},o.prototype._doAcceptFileChanges=function(e){return this._worker(function(t){return t.acceptFileChanges(e)})},o.prototype._defaultLib=function(){var t=this;if(!this._defaultLibPromise){var n=[],o=new r.TPromise(function(t,n){return e([d.defaultLib.path.substr(1)],t,n)}).then(function(e){n.push({kind:d.ChangeKind.Added,resource:d.defaultLib,content:e})}),i=new r.TPromise(function(t,n){return e([d.defaultLibES6.path.substr(1)],t,n)}).then(function(e){n.push({kind:d.ChangeKind.Added,resource:d.defaultLibES6,content:e})});this._defaultLibPromise=r.TPromise.join([o,i]).then(function(){return t.acceptFileChanges(n)})}return new a.ShallowCancelThenPromise(this._defaultLibPromise)},o.prototype._syncProjects=function(){var e=this;return this._projectResolver?this._defaultLib().then(function(){return e._projectResolver}).then(function(e){return e.resolveProjects()}):void 0},o.prototype.configure=function(e){var n=this,r=t.prototype.configure.call(this,e);return this._semanticValidator&&r.then(function(e){return e&&n._semanticValidator.validateOpen()}),r},o.prototype._worker=function(e){return t.prototype._worker.call(this,e)},o.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},o.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},o.prototype.performSemanticValidation=function(e){var t=this;return this.doValidateSemantics(e).then(function(e){return e?t.getMissingFiles().then(function(e){return e?t._projectResolver.then(function(t){return t.resolveFiles(e)}):void 0}):void 0})},o.prototype.doValidateSemantics=function(e){return this._worker(function(t){return t.doValidateSemantics(e)})},o.prototype.getMissingFiles=function(){return this._worker(function(e){return e.getMissingFiles()})},o.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},o.prototype.findOccurrences=function(e,t,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(e,t,n)})},o.prototype.suggest=function(e,t){return this._worker(function(n){return n.suggest(e,t)})},o.prototype.getSuggestionDetails=function(e,t,n){return this._worker(function(r){return r.getSuggestionDetails(e,t,n)})},o.prototype.getParameterHints=function(e,t){return this._worker(function(n){return n.getParameterHints(e,t)})},o.prototype.getEmitOutput=function(e,t){return void 0===t&&(t=void 0),this._worker(function(n){return n.getEmitOutput(e,t)})},o.prototype.getWordDefinition=function(){return o.WORD_DEFINITION},o.prototype.findReferences=function(e,t,n){return this._worker(function(r){return r.findReferences(e,t,n)})},Object.defineProperty(o.prototype,"filter",{get:function(){return["identifier.ts","string.ts"]},enumerable:!0,configurable:!0}),o.prototype.rename=function(e,t,n){return this._worker(function(r){return r.rename(e,t,n)})},o.prototype.getNavigateToItems=function(e){return this._worker(function(t){return t.getNavigateToItems(e)})},o.prototype.runQuickFixAction=function(e,t,n){var r=this,o=this._instantiationService.createInstance(u.QuickFixMainActions);return o.evaluate(e,t,n).then(function(o){return o?o:r.runQuickFixActionInWorker(e,t,n)})},o.prototype.runQuickFixActionInWorker=function(e,t,n){return this._worker(function(r){return r.runQuickFixAction(e,t,n)})},o.prototype.getQuickFixes=function(e,t){return this._worker(function(n){return n.getQuickFixes(e,t)})},o.prototype.getRangesToPosition=function(e,t){return this._worker(function(n){return n.getRangesToPosition(e,t)})},o.prototype.findDeclaration=function(e,t){return this._worker(function(n){return n.findDeclaration(e,t)})},o.prototype.computeInfo=function(e,t){return this._worker(function(n){return n.computeInfo(e,t)})},o.prototype.getAutoFormatTriggerCharacters=function(){return[";","}","\n"]},o.prototype.formatDocument=function(e,t){return this._worker(function(n){return n.formatDocument(e,t)})},o.prototype.formatRange=function(e,t,n){return this._worker(function(r){return r.formatRange(e,t,n)})},o.prototype.formatAfterKeystroke=function(e,t,n,r){return this._worker(function(o){return o.formatAfterKeystroke(e,t,n,r)})},o.prototype.enableCodeLens=function(){return this._options&&this._options.referenceInfos===!0},o.prototype.findCodeLensSymbols=function(e){return this._worker(function(t){return t.findCodeLensSymbols(e)})},o.prototype.findCodeLensReferences=function(e,t){return this._worker(function(n){return n.findCodeLensReferences(e,t)})},o.$_doAcceptProjectChanges=p.AllWorkersAttr(o,o.prototype._doAcceptProjectChanges),o.$_canAcceptFileChanges=p.OneWorkerAttr(o,o.prototype._canAcceptFileChanges),o.$_doAcceptFileChanges=p.AllWorkersAttr(o,o.prototype._doAcceptFileChanges),o.$_pickAWorkerToValidate=p.OneWorkerAttr(o,o.prototype._pickAWorkerToValidate,o.prototype._syncProjects,f.ThreadAffinity.Group3),o.$doValidateSemantics=p.OneWorkerAttr(o,o.prototype.doValidateSemantics,o.prototype._syncProjects,f.ThreadAffinity.Group3),o.$getMissingFiles=p.OneWorkerAttr(o,o.prototype.getMissingFiles,o.prototype._syncProjects,f.ThreadAffinity.Group3),o.$getOutline=p.OneWorkerAttr(o,o.prototype.getOutline,o.prototype._syncProjects,f.ThreadAffinity.Group1),o.$findOccurrences=p.OneWorkerAttr(o,o.prototype.findOccurrences,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$suggest=p.OneWorkerAttr(o,o.prototype.suggest,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$getSuggestionDetails=p.OneWorkerAttr(o,o.prototype.getSuggestionDetails,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$getParameterHints=p.OneWorkerAttr(o,o.prototype.getParameterHints,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$getEmitOutput=p.OneWorkerAttr(o,o.prototype.getEmitOutput,o.prototype._syncProjects,f.ThreadAffinity.Group3),o.WORD_DEFINITION=h.createWordRegExp("$"),o.$findReferences=p.OneWorkerAttr(o,o.prototype.findReferences,o.prototype._syncProjects,f.ThreadAffinity.Group3),o.$rename=p.OneWorkerAttr(o,o.prototype.rename,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$getNavigateToItems=p.OneWorkerAttr(o,o.prototype.getNavigateToItems,o.prototype._syncProjects,f.ThreadAffinity.Group3),o.$runQuickFixActionInWorker=p.OneWorkerAttr(o,o.prototype.runQuickFixActionInWorker,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$getQuickFixes=p.OneWorkerAttr(o,o.prototype.getQuickFixes,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$getRangesToPosition=p.OneWorkerAttr(o,o.prototype.getRangesToPosition,o.prototype._syncProjects,f.ThreadAffinity.Group1),o.$findDeclaration=p.OneWorkerAttr(o,o.prototype.findDeclaration,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$computeInfo=p.OneWorkerAttr(o,o.prototype.computeInfo,o.prototype._syncProjects,f.ThreadAffinity.Group2),o.$formatDocument=p.OneWorkerAttr(o,o.prototype.formatDocument,o.prototype._syncProjects,f.ThreadAffinity.Group1),o.$formatRange=p.OneWorkerAttr(o,o.prototype.formatRange,o.prototype._syncProjects,f.ThreadAffinity.Group1),o.$formatAfterKeystroke=p.OneWorkerAttr(o,o.prototype.formatAfterKeystroke,o.prototype._syncProjects,f.ThreadAffinity.Group1),o.findCodeLensSymbols=p.OneWorkerAttr(o,o.prototype.findCodeLensSymbols,o.prototype._syncProjects,f.ThreadAffinity.Group1),o.findCodeLensReferences=p.OneWorkerAttr(o,o.prototype.findCodeLensReferences,o.prototype._syncProjects,f.ThreadAffinity.Group3),o}(h.AbstractMode);t.TypeScriptMode=v}),define("vs/languages/javascript/common/javascript.extensions",["require","exports","vs/platform/platform"],function(e,t,n){var r;!function(e){function t(e){o=e}function r(){return o}e.Identifier="javascript",n.Registry.add(e.Identifier,e);var o;e.setProjectResolver=t,e.getProjectResolver=r}(r=t.Extensions||(t.Extensions={}))});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/javascript/common/javascript",["require","exports","vs/base/common/winjs.base","vs/languages/typescript/common/features/tokenization","vs/languages/typescript/common/typescriptMode","vs/editor/common/modes/supports","vs/languages/javascript/common/javascript.extensions","vs/editor/common/modes/abstractMode","vs/platform/instantiation/common/descriptors"],function(e,t,n,r,o,i,s,a,c){var l=function(t){function o(e,n,o){var s=this;t.call(this,e,n,o),this._workerDescriptor=c.AsyncDescriptor.create("vs/languages/javascript/common/javascriptWorker","JavaScriptWorker"),this.tokenizationSupport=r.createTokenizationSupport(this,r.Language.EcmaScript5),this.referenceSupport=new i.ReferenceSupport(this,{tokens:["identifier.js"],findReferences:function(e,t,n){return s.findReferences(e,t,n)}}),this.declarationSupport=new i.DeclarationSupport(this,{tokens:["identifier.js","string.js","attribute.value.vs"],findDeclaration:function(e,t){return s.findDeclaration(e,t)}}),this.parameterHintsSupport=new i.ParameterHintsSupport(this,{triggerCharacters:["(",","],excludeTokens:["string.js","string.escape.js"],getParameterHints:function(e,t){return s.getParameterHints(e,t)}}),this.electricCharacterSupport=new i.BracketElectricCharacterSupport(this,{brackets:[{tokenType:"delimiter.bracket.js",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.js",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.js",open:"(",close:")",isElectric:!0}],docComment:{scope:"comment.doc",open:"/**",lineStart:" * ",close:" */"}}),this.characterPairSupport=new i.CharacterPairSupport(this,{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string","comment"]}]}),this.suggestSupport=new i.SuggestSupport(this,{triggerCharacters:["."],excludeTokens:["string","comment","number"],sortBy:[{type:"reference",partSeparator:"/"}],suggest:function(e,t){return s.suggest(e,t)},getSuggestionDetails:function(e,t,n){return s.getSuggestionDetails(e,t,n)}})}return __extends(o,t),o.prototype.asyncCtor=function(){var t=this;return this._threadService.isInMainThread?n.Promise.as(this):new n.Promise(function(n){e(["vs/languages/typescript/common/typescriptWorker2"],function(){n(t)})})},o.prototype._getProjectResolver=function(){return s.Extensions.getProjectResolver()},o.prototype._shouldBeValidated=function(e){return e.getMode()===this||/\.(d\.ts|js)$/.test(e.getAssociatedResource().fsPath)},o.prototype._worker=function(e){return t.prototype._worker.call(this,e)},o.prototype.getCommentsConfiguration=function(){return{lineCommentTokens:["//"],blockCommentStartToken:"/*",blockCommentEndToken:"*/"}},o.prototype.getWordDefinition=function(){return o.JS_WORD_DEFINITION},Object.defineProperty(o.prototype,"filter",{get:function(){return["identifier.js","string.js"]},enumerable:!0,configurable:!0}),o.JS_WORD_DEFINITION=a.createWordRegExp("$"),o}(o.TypeScriptMode);t.JSMode=l});