/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
"use strict";var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/razor/common/csharpTokenization",["require","exports","vs/editor/common/modes/autoIndentation","vs/base/common/objects","vs/editor/common/modes","vs/languages/html/common/html","vs/languages/vsxml/common/vsxml","vs/editor/common/modes/abstractState","vs/editor/common/modes/abstractMode"],function(e,t,n,r,i,o,s,a,c){var l="+-*%&|^~!=<>/?;:.,",u="+-*/%&|^~!=<>(){}[]\"'\\/?;:.,",p="	 ";t.brackets=new n.Brackets([{tokenType:"delimiter.bracket.cs",open:"{",close:"}",isElectric:!0},{tokenType:"delimiter.array.cs",open:"[",close:"]",isElectric:!0},{tokenType:"delimiter.parenthesis.cs",open:"(",close:")",isElectric:!0},{tokenType:"delimiter.angle.cs",open:"<",close:">",isElectric:!1}]);var h=r.createKeywordMatcher(["abstract","as","async","await","base","bool","break","by","byte","case","catch","char","checked","class","const","continue","decimal","default","delegate","do","double","descending","explicit","event","extern","else","enum","false","finally","fixed","float","for","foreach","from","goto","group","if","implicit","in","int","interface","internal","into","is","lock","long","new","null","namespace","object","operator","out","override","orderby","params","private","protected","public","readonly","ref","return","switch","struct","sbyte","sealed","short","sizeof","stackalloc","static","string","select","this","throw","true","try","typeof","uint","ulong","unchecked","unsafe","ushort","using","var","virtual","volatile","void","while","where","yield","model","inject"]),d=function(e){return l.indexOf(e)>-1},m=function(e){function t(t,n,r){e.call(this,t),this.name=n,this.parent=r}return __extends(t,e),t.prototype.equals=function(n){if(!e.prototype.equals.call(this,n))return!1;var r=n;return n instanceof t&&this.getMode()===r.getMode()&&this.name===r.name&&(null===this.parent&&null===r.parent||null!==this.parent&&this.parent.equals(r.parent))},t.prototype.tokenize=function(e){return e.setTokenRules(u,p),e.skipWhitespace().length>0?{type:""}:this.stateTokenize(e)},t.prototype.stateTokenize=function(){throw new Error("To be implemented")},t}(a.AbstractState);t.CSState=m;var f=function(e){function t(t,n,r){e.call(this,t,"string",n),this.isAtBeginning=!0,this.delimiter=r}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.parent?this.parent.clone():null,this.delimiter)},t.prototype.equals=function(t){return e.prototype.equals.call(this,t)&&this.delimiter===t.delimiter},t.prototype.tokenize=function(e){var t=this.isAtBeginning?1:0;for(this.isAtBeginning=!1;!e.eos();){var n=e.next();if("\\"===n)return 0===t?e.eos()?{type:"string.escape.cs"}:(e.next(),e.eos()?{type:"string.escape.cs",nextState:this.parent}:{type:"string.escape.cs"}):(e.goBack(1),{type:"string.cs"});if(n===this.delimiter)break;t+=1}return{type:"string.cs",nextState:this.parent}},t}(m),g=function(e){function t(t,n){e.call(this,t,"verbatimstring",n)}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.parent?this.parent.clone():null)},t.prototype.tokenize=function(e){for(;!e.eos();){var t=e.next();if('"'===t){if(e.eos()||'"'!==e.peek())return{type:"string.cs",nextState:this.parent};e.next()}}return{type:"string.cs"}},t}(m),y=function(e){function t(t,n,r){e.call(this,t,"number",n),this.firstDigit=r}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.parent?this.parent.clone():null,this.firstDigit)},t.prototype.tokenize=function(e){var t=this.firstDigit,n=10,r=!1,i=!1;if("0"===t&&!e.eos()){if(t=e.peek(),"x"===t)n=16;else{if("."!==t)return{type:"number.cs",nextState:this.parent};n=10}e.next()}for(;!e.eos();)if(t=e.peek(),c.isDigit(t,n))e.next();else{if(10!==n)break;if("."!==t||i||r){if("e"!==t.toLowerCase()||i){if("f"===t.toLowerCase()||"d"===t.toLowerCase()){e.next();break}break}i=!0,e.next(),e.eos()||"-"!==e.peek()||e.next()}else r=!0,e.next()}var o="number";return 16===n&&(o+=".hex"),{type:o+".cs",nextState:this.parent}},t}(m),_=function(e){function t(t,n,r){e.call(this,t,"comment",n),this.commentChar=r}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.parent?this.parent.clone():null,this.commentChar)},t.prototype.tokenize=function(e){for(;!e.eos();){var t=e.next();if("*"===t&&!e.eos()&&!e.peekWhitespace()&&e.peek()===this.commentChar)return e.next(),{type:"comment.cs",nextState:this.parent}}return{type:"comment.cs"}},t}(m);t.CSComment=_;var b=function(e){function n(t,n,r,i,o,a,c,l){e.call(this,t,"expression",n),this.level=r,this.plevel=i,this.razorMode=o,this.expression=a,this.vsState=new s.VSXMLExpression(t,null),this.firstToken=c,this.firstTokenWasKeyword=l}return __extends(n,e),n.prototype.setVSXMLState=function(e){this.vsState=e},n.prototype.makeClone=function(){var e=new n(this.getMode(),this.parent?this.parent.clone():null,this.level,this.plevel,this.razorMode,this.expression,this.firstToken,this.firstTokenWasKeyword);return null!==this.vsState&&e.setVSXMLState(this.vsState.clone()),e},n.prototype.equals=function(t){return e.prototype.equals.call(this,t)&&t instanceof n&&(null===this.vsState&&null===t.vsState||null!==this.vsState&&this.vsState.equals(t.vsState))},n.prototype.stateTokenize=function(e){if(c.isDigit(e.peek(),10))return this.firstToken=!1,{nextState:new y(this.getMode(),this,e.next())};var n=e.nextToken(),r=!this.firstTokenWasKeyword,i=this.level<=0&&this.plevel<=0&&e.eos()?this.parent:void 0;if(e.eos()&&(this.firstTokenWasKeyword=!1),h(n))return this.level<=0&&(this.expression=!1),this.firstToken&&(this.firstTokenWasKeyword=!0),{type:"keyword.cs"};if(this.firstToken=!1,this.razorMode&&"<"===n&&r&&!e.eos()&&/[_:!\/\w]/.test(e.peek()))return{nextState:new v(this.getMode(),this,o.States.Content)};if(this.razorMode&&this.expression&&this.level<=0&&this.plevel<=0&&!e.eos()&&(/^(\.|\[|\(|\{\w+)$/.test(e.peekToken())||(i=this.parent)),"/"===n){if(!e.eos()&&!e.peekWhitespace())switch(e.peekToken()){case"/":if(e.nextToken(),!e.eos()&&"/"===e.peekToken()){if(e.nextToken(),e.eos())return{type:"comment.vs"};if("/"!==e.peekToken())return{type:"comment.vs",nextState:new s.VSXMLEmbeddedState(this.getMode(),this.vsState,this)}}return e.advanceToEOS(),{type:"comment.cs"};case"*":return e.nextToken(),{nextState:new _(this.getMode(),this,"/")}}return{type:"delimiter.cs",nextState:i}}if("@"===n&&!e.eos())switch(e.peekToken()){case'"':return e.nextToken(),{nextState:new g(this.getMode(),this)};case"*":return e.nextToken(),{nextState:new _(this.getMode(),this,"@")}}if(/@?\w+/.test(n))return{type:"ident.cs",nextState:i};if('"'===n||"'"===n)return{nextState:new f(this.getMode(),this,n)};if(t.brackets.stringIsBracket(n)){var a={bracket:t.brackets.bracketTypeFromString(n),type:t.brackets.tokenTypeFromString(n),nextState:i};return this.razorMode&&("{"===n&&(this.expression=!1,this.level++,1===this.level&&(a.type="metatag.cshtml",a.nextState=void 0)),"}"===n&&(this.level--,this.level<=0&&(a.type="metatag.cshtml",a.nextState=this.parent)),this.expression&&("("===n&&(this.plevel++,1===this.plevel&&(a.type="metatag.cshtml",a.nextState=void 0)),")"===n&&(this.plevel--,this.expression&&this.plevel<=0&&(a.type="metatag.cshtml",a.nextState=this.parent)),"["===n&&(this.plevel++,a.nextState=void 0),"]"===n&&this.plevel--)),a}return d(n)?{type:"delimiter.cs",nextState:i}:this.razorMode&&this.expression&&this.plevel<=0?{type:"",nextState:this.parent}:{type:"",nextState:i}},n}(m);t.CSStatement=b;var T=["area","base","basefont","br","col","frame","hr","img","input","isindex","link","meta","param"],v=function(e){function t(t,n,r){e.call(this,t,"number",n),this.state=r}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.parent?this.parent.clone():null,this.state)},t.prototype.nextName=function(e){return e.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/)},t.prototype.nextAttrValue=function(e){return e.advanceIfRegExp(/^('|').*?\1/)},t.prototype.tokenize=function(e){switch(this.state){case o.States.WithinComment:if(e.advanceUntil("-->",!1).length>0)return{type:"comment.html.content"};if(e.advanceIfString("-->").length>0)return this.state=o.States.Content,{type:"comment.html",bracket:i.Bracket.Close,nextState:this.parent};break;case o.States.WithinDoctype:if(e.advanceUntil(">",!1).length>0)return{type:"metatag.content.html"};if(e.advanceIfString(">").length>0)return this.state=o.States.Content,{type:"metatag.html",bracket:i.Bracket.Close,nextState:this.parent};break;case o.States.Content:return e.advanceIfString("!--").length>0?(this.state=o.States.WithinComment,{type:"comment.html",bracket:i.Bracket.Open}):e.advanceIfRegExp(/!DOCTYPE/i).length>0?(this.state=o.States.WithinDoctype,{type:"metatag.html",bracket:i.Bracket.Open}):e.advanceIfString("/").length>0?(this.state=o.States.OpeningEndTag,{type:"delimiter.end.html",bracket:i.Bracket.Open}):(this.state=o.States.OpeningStartTag,{type:"delimiter.start.html",bracket:i.Bracket.Open});case o.States.OpeningEndTag:var t=this.nextName(e);return t.length>0?{type:"tag.html.tag-"+t,bracket:-1!==T.indexOf(t)?-1:i.Bracket.Close}:e.advanceIfString(">").length>0?(this.state=o.States.Content,{type:"delimiter.end.html",bracket:i.Bracket.Close,nextState:this.parent}):(e.advanceUntil(">",!1),{type:""});case o.States.OpeningStartTag:var t=this.nextName(e);if(t.length>0)return this.state=o.States.WithinTag,{type:"tag.html.tag-"+t,bracket:-1!==T.indexOf(t)?-1:i.Bracket.Open};break;case o.States.WithinTag:if(e.skipWhitespace().length>0)return{type:""};var n=this.nextName(e);return n.length>0?(this.state=o.States.AttributeName,{type:"attribute.name.html"}):e.advanceIfRegExp(/^\/?>/).length>0?(this.state=o.States.Content,{type:"delimiter.start.html",bracket:i.Bracket.Close,nextState:this.parent}):(e.next(),{type:""});case o.States.AttributeName:return e.skipWhitespace().length>0||e.eos()?{type:""}:"="===e.peek()?(e.next(),this.state=o.States.AttributeValue,{type:""}):(this.state=o.States.WithinTag,this.tokenize(e));case o.States.AttributeValue:if(e.skipWhitespace().length>0||e.eos())return{type:""};var r=this.nextAttrValue(e);return r.length>0?(this.state=o.States.WithinTag,{type:"attribute.value.html"}):(this.state=o.States.WithinTag,this.tokenize(e))}return e.next(),this.state=o.States.Content,{type:"",nextState:this.parent}},t}(m)});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);n.prototype=t.prototype,e.prototype=new n};define("vs/languages/razor/common/razor",["require","exports","vs/languages/html/common/html","vs/languages/razor/common/csharpTokenization","vs/editor/common/modes/abstractMode","vs/platform/instantiation/common/descriptors"],function(e,t,n,r,i,o){var s=function(e){function t(t,n,r,i,o,s,a){e.call(this,t,n,r,i,o,s,a)}return __extends(t,e),t.prototype.makeClone=function(){return new t(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},t.prototype.equals=function(n){return n instanceof t?e.prototype.equals.call(this,n):!1},t.prototype.tokenize=function(t){if(!t.eos()&&"@"===t.peek()){if(t.next(),!t.eos()&&"*"===t.peek())return{nextState:new r.CSComment(this.getMode(),this,"@")};if(t.eos()||"@"!==t.peek())return{type:"metatag.cshtml",nextState:new r.CSStatement(this.getMode(),this,0,0,!0,!0,!0,!1)}}return e.prototype.tokenize.call(this,t)},t}(n.State),a=function(e){function t(t,n,r){e.call(this,t,n,r,o.AsyncDescriptor.create("vs/languages/razor/common/razorWorker","RAZORWorker")),this.formattingSupport=null}return __extends(t,e),t.prototype.getInitialState=function(){return new s(this,n.States.Content,"","","","","")},t.prototype.getWordDefinition=function(){return t.WORD_DEFINITION},t.prototype.getLeavingNestedModeData=function(t,r){var i=e.prototype.getLeavingNestedModeData.call(this,t,r);return i&&(i.stateAfterNestedMode=new s(this,n.States.Content,"","","","","")),i},t.WORD_DEFINITION=i.createWordRegExp("#?%"),t}(n.HTMLMode);t.RAZORMode=a});